//----------------------------------------------------------------------------
#ifndef SDIMainH
#define SDIMainH
//----------------------------------------------------------------------------
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <StdCtrls.hpp>
#include <Dialogs.hpp>
#include <Menus.hpp>
#include <Controls.hpp>
#include <Forms.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <System.hpp>
#include <ActnList.hpp>
#include <ImgList.hpp>
#include <StdActns.hpp>
#include <ToolWin.hpp>
#include "ALAudioToReal.h"
#include "ALCommonSplitter.h"
#include "SLScope.h"
#include "VLCommonDisplay.h"
#include "VLDSVideoPlayer.h"
#include "VLImageDisplay.h"
#include "ALAudioOut.h"
#include "SLWaterfall.h"
#include "SLFourier.h"
#include "SLCommonFilter.h"
#include "SLLowPass.h"
#include "SLSimpleFilter.h"
#include "VLAVIPlayer.h"
#include "SLBandFilter.h"
#include "SLBandPass.h"
#include "SLGenericReal.h"
#include "SLGenericComplex.h"
#include "SLDft.h"
#include "SLGoertzOne.h"
#include "SLGenericFilter.h"
#include <OleCtrls.hpp>
#include <SHDocVw.hpp>
#include "SHDocVw_OCX.h"
#include "ALRealToAudio.h"
#include "ALCommonFilter.h"
#include "ALGenericFilter.h"
//----------------------------------------------------------------------------
class TSDIAppForm : public TForm
{
__published:
    TOpenDialog *OpenDialog;
    TSaveDialog *SaveDialog;
    TToolBar *ToolBar1;
    TToolButton *ToolButton9;
    TToolButton *ToolButton1;
    TToolButton *ToolButton2;
    TToolButton *ToolButton3;
    TToolButton *ToolButton4;
    TToolButton *ToolButton5;
    TToolButton *ToolButton6;
    TActionList *ActionList1;
    TAction *FileNew1;
    TAction *FileOpen1;
    TAction *FileSave1;
    TAction *FileSaveAs1;
    TAction *FileExit1;
    TEditCut *EditCut1;
    TEditCopy *EditCopy1;
    TEditPaste *EditPaste1;
    TAction *HelpAbout1;
    TStatusBar *StatusBar;
    TImageList *ImageList1;
    TMainMenu *MainMenu1;
    TMenuItem *File1;
    TMenuItem *FileNewItem;
    TMenuItem *FileOpenItem;
    TMenuItem *FileSaveItem;
    TMenuItem *FileSaveAsItem;
    TMenuItem *N1;
    TMenuItem *FileExitItem;
    TMenuItem *Edit1;
    TMenuItem *CutItem;
    TMenuItem *CopyItem;
    TMenuItem *PasteItem;
    TMenuItem *Help1;
    TMenuItem *HelpAboutItem;
	TVLImageDisplay *VLImageDisplay1;
	TALAudioToReal *ALAudioToReal1;
	TSLScope *GoertzelScope;
	TMemo *Memo1;
	TSLGoertzOne *SLGoertzOne1366;
	TSLGoertzOne *SLGoertzOne1209;
	TSLGoertzOne *SLGoertzOne1633;
	TSLGoertzOne *SLGoertzOne697;
	TSLGoertzOne *SLGoertzOne1477;
	TSLGoertzOne *SLGoertzOne770;
	TSLGoertzOne *SLGoertzOne852;
	TSLGoertzOne *SLGoertzOne941;
	TTimer *Timer1;
	TCppWebBrowser *CppWebBrowser1;
	TLabel *Label1;
	TMemo *LogMemo;
	TBitBtn *StopBtn;
	TBitBtn *PlayBtn;
	TBitBtn *BitBtn1;
	TLabel *Label2;
	TScrollBar *ScrollBar1;
	TTimer *scrolltimer;
	TSLBandPass *SLBandPass1;
	TSLScope *SLScope1;
	TTrackBar *ThresBar;
	TLabel *Label3;
	TVLDSVideoPlayer *VideoPlayer;
	TVLAVIPlayer *VLAVIPlayer1;void __fastcall FileNew1Execute(TObject *Sender);
        void __fastcall FileOpen1Execute(TObject *Sender);
        void __fastcall FileSave1Execute(TObject *Sender);
        void __fastcall FileExit1Execute(TObject *Sender);
        void __fastcall HelpAbout1Execute(TObject *Sender);

	void __fastcall SLGoertzOne1209Calculate(TObject *Sender, Real RealValue,
          Real ImaginaryValue, Real SpectrumValue);
	void __fastcall SLGoertzOne1366Calculate(TObject *Sender, Real RealValue,
          Real ImaginaryValue, Real SpectrumValue);
	void __fastcall SLGoertzOne1477Calculate(TObject *Sender, Real RealValue,
          Real ImaginaryValue, Real SpectrumValue);
	void __fastcall SLGoertzOne1633Calculate(TObject *Sender, Real RealValue,
          Real ImaginaryValue, Real SpectrumValue);
	void __fastcall SLGoertzOne697Calculate(TObject *Sender, Real RealValue,
          Real ImaginaryValue, Real SpectrumValue);
	void __fastcall SLGoertzOne770Calculate(TObject *Sender, Real RealValue,
          Real ImaginaryValue, Real SpectrumValue);
	void __fastcall SLGoertzOne852Calculate(TObject *Sender, Real RealValue,
          Real ImaginaryValue, Real SpectrumValue);
	void __fastcall SLGoertzOne941Calculate(TObject *Sender, Real RealValue,
          Real ImaginaryValue, Real SpectrumValue);
	void __fastcall FormCreate(TObject *Sender);

	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall StopBtnClick(TObject *Sender);
	void __fastcall PlayBtnClick(TObject *Sender);
	void __fastcall BitBtn1Click(TObject *Sender);
	void __fastcall scrolltimerTimer(TObject *Sender);
	void __fastcall ScrollBar1Scroll(TObject *Sender, TScrollCode ScrollCode,
          int &ScrollPos);
	void __fastcall VideoPlayerProgress(TObject *Sender, __int64 StartFrame,
          __int64 EndFrame, __int64 CurrentFrame);
private:
public:
		void parseDTMF();
		virtual __fastcall TSDIAppForm(TComponent *AOwner);
		char lat[16],lon[16];
};
//----------------------------------------------------------------------------
extern TSDIAppForm *SDIAppForm;
//----------------------------------------------------------------------------

#endif
